/***********************************************
*  OtBbNLCD(12864hbgjpCu
*  PIC18 32MHzp@
*	lcd_Write();
*	lcd_Read();
*	lcd_Init();
*	lcd_Clear();
*	lcd_Pixel();
*	lcd_Char();
*	lcd_Char1();
*	lcd_Str();
*	lcd_Line();
*	lcd_Circle();
*	Delay1m();
************************************************/
#include <p18f26j11.h>
#include "glcd_lib2.h"
#include "font.h"
#include <delays.h>
/***********************************
 f[^o͊֐ (8rbgój
***********************************/
void lcd_Write(char cs, unsigned char code, char DIflag){
	if(cs==1)				// `bvI
		LCD_CS1 = 0;
	else
		LCD_CS2 = 0;
	LCD_RW = 0;				// write[hؑ
	LCD_DB = code;
	if (DIflag == 0)
		LCD_DI = 1;			// \f[^̏ꍇ 
	else
		LCD_DI = 0;			// R}hf[^̏ꍇ
	Nop();					// x@140nsecȏ 
	LCD_E = 1;				// Xg[uI
	Delay10TCYx(1);			// pXm 1.2usec
	LCD_E = 0;				// Xg[uIt
	LCD_CS1 = 1;				// `bvIIt
	LCD_CS2 = 1;
	while((lcd_Read(cs, 1) & 0x80) != 0);
}
/*****************************
* f[^ǂݏo֐@
*****************************/
unsigned char lcd_Read(char cs, char DIflag){
	unsigned char data;

	LCD_TRIS = 0xFF;			// DB̓[hɕύX
	if(cs==1)				// `bvI
		LCD_CS1 = 0;
	else
		LCD_CS2 = 0;
	LCD_RW = 1;				// Read[h
	if (DIflag == 0)
		LCD_DI = 1;			// \f[^̏ꍇ 
	else
		LCD_DI = 0;			// Xe[^X̏ꍇ
	Nop();					// x 140nsecȏ 
	LCD_E = 1;				// Xg[uI
	Delay10TCYx(2);			// f[^o͑҂@2.5usec
	data = LCD_DB;			// f[^荞
	LCD_E = 0;				// Xg[uIt
	LCD_CS1 = 1;				// `bvIIt
	LCD_CS2 = 1;
	LCD_TRIS = 0x00;			// DBo̓[hɖ߂
	return(data);			// f[^Ԃ
}
/***************************
* ʏ֐
****************************/
void lcd_Clear(unsigned char data){
	char page, colum;	
	
	for(page=0; page<8; page++){			// 8y[WJԂ
		lcd_Write(1, 0xB8+page, 1);		// y[WAhXZbg
		lcd_Write(1, 0x40, 1);				// RAhXZbg
		lcd_Write(2, 0xB8+page, 1);		// y[WAhXZbg
		lcd_Write(2, 0x40, 1);				// RAhXZbg
		for(colum=0; colum<64; colum++){	// 64JԂ
			lcd_Write(1, data, 0);			// Edata
			lcd_Write(2, data, 0);			// data
		}
	}
}	
/****************************
* ֐  
*****************************/
void lcd_Init(void){
	while((lcd_Read(1, 1) & 0x10) != 0);	// Zbg슮҂
	while((lcd_Read(2, 1) & 0x10) != 0);	// Zbg슮҂	
	lcd_Write(1, 0x3F, 1);					// \I
	lcd_Write(2, 0x3F, 1);					// \I
	lcd_Write(1, 0xC0, 1);					// JnC擪ɂ
	lcd_Write(2, 0xC0, 1);					// JnC擪ɂ		
	lcd_Clear(0);							// S
}
/******************************************
*  Draw Pixel Function
*  W͍E(0,0)-(127,63)  
*******************************************/
void lcd_Pixel(int Xpos, int Ypos, char On){
	unsigned char cs, _data, page, count, i, pos;

	/*** W̕ϊ ***/
	if((Xpos >= 0) && (Xpos<128) && (Ypos < 64) && (Ypos >= 0)){
		if(Xpos>63){							// 64ȏォ
			Xpos = Xpos-64;					// RAhXɕύX
			cs = 1;							// E
		}
		else
			cs = 2;							// 
		page = (unsigned char)(7-Ypos/8);		// y[WAhX]
		/* AhXݒƌ݃f[^ǂݏo */
		lcd_Write(cs, 0xB8+page, 1);			// y[WAhXZbg			
		lcd_Write(cs, 0x40+Xpos, 1);			// RAhXZbg
		_data = lcd_Read(cs, 0);				// _~[
		_data = lcd_Read(cs, 0);				// ݕ\f[^ǂݏo
		/* hbgʒũf[^쐬 */
		pos =1;								// rbgf[^
		count = (unsigned char)(7-Ypos%8);		// rbgʒu߂
		for(i=0; i<count; i++)					// 8rbgf[^ɕϊ
			pos *= 2;
		lcd_Write(cs, 0x40+Xpos, 1);			// RAhXĐݒ
		/* XVď */
		if(On==1)							// \I
			lcd_Write(cs, _data | pos, 0);		// ORłPɂ
		else{
			lcd_Write(cs, _data & (~pos), 0);	// _]AND0ɂ
		}
	}
}
/***************************
*  `֐
***************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void lcd_Line(int x0, int y0, int x1, int y1)
{
	int steep, t;
	int	deltax, deltay, error;
	int x, y;
	int ystep;
	
	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}
	deltax = x1 - x0;						// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) ystep = 1; else ystep = -1;
	/// _ŕ`
	for(x=x0; x<=x1; x++) {
		if(steep) lcd_Pixel(y,x,1); else lcd_Pixel(x,y,1);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}

/*************************************
*  ~`֐
*  S_Ɣaw
*  (FussỹASYgp)
**************************************/
void lcd_Circle(int x0, int y0, int r)
{
	int x = r;
	int y = 0;
	int F = -2 * r + 3;
	
	while(x >= y){
		lcd_Pixel(x0+x, y0+y, 1);
		lcd_Pixel(x0-x, y0+y, 1);		
		lcd_Pixel(x0+x, y0-y, 1);
		lcd_Pixel(x0-x, y0-y, 1);		
		lcd_Pixel(x0+y, y0+x, 1);
		lcd_Pixel(x0-y, y0+x, 1);		
		lcd_Pixel(x0+y, y0-x, 1);
		lcd_Pixel(x0-y, y0-x, 1);
		if(F >= 0){
			x--;
			F -= 4 * x;
		}
		y++;
		F += 4 * y + 2;
	}
}

/*************************
*  \֐ 8x8
*  (0, 0) - (7, 15)
**************************/
void lcd_Char(char line, char colum, unsigned int letter){
	char cs, i;
	int pos;
	
	/* ʒuRAy[WAhXɕϊݒ */  
	if(colum < 16){
		if(colum > 7){
			pos = (colum- 8) * 8;
		  	cs = 1;
		}
		else{
		  	pos = colum * 8;
		  	cs = 2;
		}
		lcd_Write(cs, 0xB8+line, 1);		// y[WAhXZbg
		lcd_Write(cs, 0x40+pos, 1);		// RAhXZbg
		/* tHgf[^̏ */
		for(i=0; i<5; i++)
			lcd_Write(cs, Font[letter][i], 0);
		lcd_Write(cs, 0, 0);
		lcd_Write(cs, 0, 0);
		lcd_Write(cs, 0, 0);
	}
}
/*************************
*  \֐2 7x8
*  (0, 0) - (7, 17)
**************************/
void lcd_Char1(char line, char colum, unsigned int letter){
	char cs, i;
	int pos;

	/* ʒuRAy[WAhXɕϊݒ */	  
	if(colum < 18){
		if(colum > 8){
			pos = (colum- 9) * 7;
		  	cs = 1;
		}
		else{
		  	pos = colum * 7;
		  	cs = 2;
		}
		lcd_Write(cs, 0xB8+line, 1);		// y[WAhXZbg
		lcd_Write(cs, 0x40+pos, 1);		// RAhXZbg
		/* tHgf[^ */
		for(i=0; i<5; i++)
			lcd_Write(cs, Font[letter][i], 0);
		lcd_Write(cs, 0, 0);
		lcd_Write(cs, 0, 0);
	}
}
/******************************
*   `֐
******************************/
void lcd_Str(char line, char colum, char *s)
{
    while (*s)
        lcd_Char1(line, colum++, *s++);
}

/******************************************
* x֐ 
******************************************/	
/** 1msec Delay SubFunction at 8MIPS ***/
void Delay1m(int time){
	while(time > 0){
		Delay100TCYx(Fcy*10);				// 1msec
		time--;
	}
}

